use crate::{
    bussy::PubSub,
    utils::{error::Error, structs::Subscription},
};
use async_trait::async_trait;
use nostr::Event;
use std::sync::Arc;

#[async_trait]
pub trait Noose: Send + Sync {
    async fn start(&mut self, pubsub: Arc<PubSub>) -> Result<(), Error>;

    async fn migration_up(&self);

    async fn write_event(&self, event: Box<Event>) -> Result<String, Error>;

    async fn find_event(&self, subscription: Subscription) -> Result<Vec<String>, Error>;
}
