use crate::relay::ws;
use crate::utils::structs::Context;
use std::net::SocketAddr;
use warp::{Rejection, Reply};

pub async fn ws_handler(
    ws: warp::ws::Ws,
    context: Context,
    real_client_ip: Option<SocketAddr>,
) -> Result<impl Reply, Rejection> {
    Ok(ws.on_upgrade(move |socket| ws::client_connection(socket, context, real_client_ip)))
}
